<template>
  <div >
    <DepartmentForm
      v-bind.sync="note"
      v-on:submit="submit"
      v-on:cancel="cancel"
    >
    </DepartmentForm>
  </div>
</template>

<script>
import DepartmentForm from '@/components/department/DepartmentForm.vue';
import { mapGetters } from 'vuex';
import { getAuthenticatedUser } from '@/fb';
import DepartmentNote from '@/models/DepartmentNote';

export default {
  components: {
    DepartmentForm,
  },
  data() {
    return {
      note: new DepartmentNote(),
    };
  },
  computed: {
    ...mapGetters({
      snackbarText: 'getSnackbarText',
      showSnackbar: 'getShowSnackbar',
    }),
  },
  mounted() {
    getAuthenticatedUser().then((user) => {
      console.log('Got user: ', user);
      this.note.uid = user.uid;
    });
  },
  methods: {
    submit() {
      this.note.create().then(() => {
        console.log('Done creating note', this.note.id);
        this.$store.dispatch('setSnackbarText', 'Created new note');
        this.$store.dispatch('setShowSnackbar', true);
        this.$router.replace({ name: 'DepartmentList' });
      });
    },
    cancel() {
      this.$router.replace({ name: 'DepartmentList' });
    },
  },
};
</script>
